SettingsWindow = class(Turbine.UI.Lotro.Window);

function SettingsWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor(self);
	self:SetPosition(settings.settingswindow.position.left, settings.settingswindow.position.top);
	self:SetSize(360, 450);
	self:SetText("Settings");

    self.chattypes = {};

    -- mem usage
    self.memusage = Turbine.UI.Label();
    self.memusage:SetParent(self);
    self.memusage:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
    self.memusage:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
    self.memusage:SetPosition(30, 45);
    self.memusage:SetSize(200, 20);
    self.memusage:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
    self.memusage:SetText(memUsage());

    -- clear button
    self.clearbutton = Turbine.UI.Lotro.Button();
    self.clearbutton:SetParent(self);
    self.clearbutton:SetText("Clear history");
    self.clearbutton:SetPosition(225, 45);
    self.clearbutton:SetSize(110, 20);
    self.clearbutton.Click = function()
        self:ClearHistory();
    end

    -- timestamp checkbox
    self.timestamp = self:CheckBox("Show timestamps", 0);
    self.timestamp:SetPosition(190, 75);
    self.timestamp:SetSize(140, 20);
    self.timestamp.Update = function()
        if self.timestamp.Checked ~= self.timestamp:IsChecked() then
            self.timestamp.Checked = self.timestamp:IsChecked();
            showtimestamps = self.timestamp.Checked;
            saveSettings();
            mainWindow:ReloadHistory();
        end
    end
    -- hack: reuse self:CheckBox constructor,
    --       then clear timestamp from chattypes
    self.chattypes = {};

    -- channels header
    self.channelheader = self:Header("Channels");
    self.channelheader:SetPosition(0, 95);

    -- admin
    self.admin = self:CheckBox("Admin", Turbine.ChatType.Admin);
    self.admin:SetPosition(30, 120);
    -- advancement
    self.advancement = self:CheckBox("Advancement", Turbine.ChatType.Advancement);
    self.advancement:SetPosition(30, 140);
    -- advice
    self.advice = self:CheckBox("Advice", Turbine.ChatType.Advice);
    self.advice:SetPosition(30, 160);
    -- combat
    self.combat = self:CheckBox("Combat", Turbine.ChatType.Combat);
    self.combat:SetPosition(30, 180);
    -- death
    self.death = self:CheckBox("Death", Turbine.ChatType.Death);
    self.death:SetPosition(30, 200);
    -- emote
    self.emote = self:CheckBox("Emote", Turbine.ChatType.Emote);
    self.emote:SetPosition(30, 220);
    -- error
    self.cerror = self:CheckBox("Error", Turbine.ChatType.Error);
    self.cerror:SetPosition(30, 240);
    -- fellowship
    self.fellowship = self:CheckBox("Fellowship", Turbine.ChatType.Fellowship);
    self.fellowship:SetPosition(30, 260);
    -- kinship
    self.kinship = self:CheckBox("Kinship", Turbine.ChatType.Kinship);
    self.kinship:SetPosition(30, 280);
    -- LFF
    self.lff = self:CheckBox("LFF", Turbine.ChatType.LFF);
    self.lff:SetPosition(30, 300);
    -- OOC
    self.ooc = self:CheckBox("OOC", Turbine.ChatType.OOC);
    self.ooc:SetPosition(30, 320);
    -- officer
    self.officer = self:CheckBox("Officer", Turbine.ChatType.Officer);
    self.officer:SetPosition(30, 340);
    -- quest
    self.quest = self:CheckBox("Quest", Turbine.ChatType.Quest);
    self.quest:SetPosition(30, 360);
    -- raid
    self.raid = self:CheckBox("Raid", Turbine.ChatType.Raid);
    self.raid:SetPosition(30, 380);

    -- regional
    self.regional = self:CheckBox("Regional", Turbine.ChatType.Regional);
    self.regional:SetPosition(210, 120);
    -- roleplay
    self.roleplay = self:CheckBox("RP", Turbine.ChatType.Roleplay);
    self.roleplay:SetPosition(210, 140);
    -- say
    self.say = self:CheckBox("Say", Turbine.ChatType.Say);
    self.say:SetPosition(210, 160);
    -- standard
    self.standard = self:CheckBox("Standard", Turbine.ChatType.Standard);
    self.standard:SetPosition(210, 180);
    -- tell
    self.tell = self:CheckBox("Tell", Turbine.ChatType.Tell);
    self.tell:SetPosition(210, 200);
    -- trade
    self.trade = self:CheckBox("Trade", Turbine.ChatType.Trade);
    self.trade:SetPosition(210, 220);
    -- tribe
    self.tribe = self:CheckBox("Tribe", Turbine.ChatType.Tribe);
    self.tribe:SetPosition(210, 240);
    -- undef
    self.undef = self:CheckBox("Undef", Turbine.ChatType.Undef);
    self.undef:SetPosition(210, 260);
    -- unfiltered
    self.unfiltered = self:CheckBox("Unfiltered", Turbine.ChatType.Unfiltered);
    self.unfiltered:SetPosition(210, 280);
    -- userchat1
    self.userchat1 = self:CheckBox("UserChat1", Turbine.ChatType.UserChat1);
    self.userchat1:SetPosition(210, 300);
    -- userchat2
    self.userchat2 = self:CheckBox("UserChat2", Turbine.ChatType.UserChat2);
    self.userchat2:SetPosition(210, 320);
    -- userchat3
    self.userchat3 = self:CheckBox("UserChat3", Turbine.ChatType.UserChat3);
    self.userchat3:SetPosition(210, 340);
    -- userchat4
    self.userchat4 = self:CheckBox("UserChat4", Turbine.ChatType.UserChat4);
    self.userchat4:SetPosition(210, 360);

    -- save button
    self.savebutton = Turbine.UI.Lotro.Button();
    self.savebutton:SetParent(self);
    self.savebutton:SetText("Save");
    self.savebutton:SetPosition(140, 410);
    self.savebutton:SetSize(80, 20);
    self.savebutton.Click = function()
        self:Save();
    end
end

function SettingsWindow:Toggle()
    if (self:IsVisible()) then
        self:SetVisible(false);
    else
        self.timestamp:SetChecked(showtimestamps);

        for _,checkbox in pairs(self.chattypes) do
            checkbox:SetChecked(channels[checkbox.ChatType]);
        end

        self:SetVisible(true);
        self:Activate();
    end
end

function SettingsWindow:Save()
    self:SetVisible(false);
end

function SettingsWindow:ClearHistory()
    history = {};
    lines = 0;
    bytes = 0;
    self.memusage:SetText(memUsage());
    mainWindow:ReloadHistory();
end

function SettingsWindow:Header(name)
    local header = Turbine.UI.Label();
    header:SetParent(self);
    header:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
    header:SetForeColor(Turbine.UI.Color(0.95, 0.95, 0.3));
    header:SetSize(self:GetWidth(), 25);
    header:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
    header:SetText(name);
    return header;
end

function SettingsWindow:CheckBox(name, chattype)
    local checkbox = Turbine.UI.Lotro.CheckBox();
    checkbox:SetParent(self);
    checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
    checkbox:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
    checkbox:SetSize(120, 20);
    checkbox:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleRight);
    checkbox:SetText(name);
    checkbox.ChatType = chattype;
    -- workaround for CheckBox.CheckedChanged not working
    checkbox.Checked = false;
    checkbox:SetWantsUpdates(false);
    checkbox.FocusGained = function()
        checkbox:SetWantsUpdates(true);
    end
    checkbox.FocusLost = function()
        checkbox:SetWantsUpdates(false);
    end
    checkbox.Update = function()
        if checkbox.Checked ~= checkbox:IsChecked() then
            checkbox.Checked = checkbox:IsChecked();
            channels[checkbox.ChatType] = checkbox.Checked;
            saveSettings();
            mainWindow:ReloadHistory();
        end
    end
    table.insert(self.chattypes, checkbox);
    return checkbox;
end
